'---- -  
'          ** SOUND CARD FM CHIP LIBRARY FUNCTIONS **
'                  Created by Davey W Taylor
'
' This is the routines that you should use in your program game.
' Check XSMREAD.BAS for an example of how to use theese routines.
' This program will only read XSM (eXtra Simple Music) files. What
' this program really needs is a CMF/MID to XSM converter. I tried
' to load CMF files, but I just didn't get the hang of it.. :(
' I anybody out there has got some BASIC code that reads CMF files
' I would be very greatful if you could send it to me! (Check email
' below) Well, anyway if you use any of this code in your program
' please mention my name or I'll, I'll... get real mad at ya! ;)
' A lot of thanks go to Thomas Lipschultz SOUNDCARd library where
' I got a lot of ideas for this program.
'---     
' ** If you have any comments / suggestions / questions, my email is: **
' ** audio.squad@mailbox.swipnet.se                         <<< EMAIL **

DECLARE FUNCTION Detect% ()
DECLARE FUNCTION ReadXSM% (musx$)
DECLARE FUNCTION SongLength! ()
DECLARE SUB FMInit ()
DECLARE SUB VarInit ()
DECLARE SUB FMSetInstrument (chan%, inst$)
DECLARE SUB PlayNextNote ()
DECLARE SUB FMPlayNote (chan%, note%, octv%)
DECLARE SUB FMStopNote (chan%)
DECLARE SUB WriteReg (reg%, info%)
DIM SHARED Delay!
DIM SHARED NoteNum%, SongLen%
DIM SHARED Music(8, 3199) AS INTEGER      'memory for 9 channels at 3200 notes
DIM SHARED NoteF(12) AS INTEGER
DIM SHARED InstType(8) AS STRING * 16
DIM SHARED Pitch%

'Speed test for some computers:
' 486PS2 33MHz 108.7%
' 486DX4 80MHz 108.6%
' P133         108.6%
'
'Tested with theese FM cards:
' Aztech Sound Galaxy
' Sound Blaster 16
' Sound Blaster Pro

FUNCTION Detect%                'Detect the prescense of a FM chip
 WriteReg 4, &H60
 WriteReg 4, &H80
 data1% = INP(&H388)
 WriteReg 2, &HFF
 WriteReg 4, &H21
 FOR d% = 1 TO 150: x% = INP(&H388): NEXT d%
 data2% = INP(&H388)
 WriteReg 4, &H60
 WriteReg 4, &H80
 IF (data1% AND &HE0) = 0 AND (data2% AND &HE0) = &HC0 THEN Detect% = -1
END FUNCTION

SUB FMInit                       'Make a rough initialisation of the FM chip
 FOR n% = 0 TO &HF5
  WriteReg n%, 0
 NEXT n%
END SUB

SUB FMPlayNote (chan%, note%, octv%)      'SUB to play a note
 freq% = NoteF%(note%)
 IF note% = 0 AND octv% = 0 THEN freq% = 0
 WriteReg &HA0 + chan%, freq% AND &HFF
 WriteReg &HB0 + chan%, INT(freq% / 256) OR 32 OR (octv% * 4)
END SUB

SUB FMSetInstrument (chan%, inst$)              'SUB to set and instrument
 chanx% = (chan% MOD 3) + 8 * INT(chan% / 3)
 WriteReg &H20 + chanx%, ASC(MID$(inst$, 1, 1)) 'AMP/VIB/EG/KSR/MFM
 WriteReg &H23 + chanx%, ASC(MID$(inst$, 2, 1))
 WriteReg &H40 + chanx%, ASC(MID$(inst$, 3, 1)) 'LKS/TL
 WriteReg &H43 + chanx%, ASC(MID$(inst$, 4, 1))
 WriteReg &H60 + chanx%, ASC(MID$(inst$, 5, 1)) 'AR/DR
 WriteReg &H63 + chanx%, ASC(MID$(inst$, 6, 1))
 WriteReg &H80 + chanx%, ASC(MID$(inst$, 7, 1)) 'SL/RR
 WriteReg &H83 + chanx%, ASC(MID$(inst$, 8, 1))
 WriteReg &HE0 + chanx%, ASC(MID$(inst$, 9, 1)) 'WFS
 WriteReg &HE3 + chanx%, ASC(MID$(inst$, 10, 1))
 WriteReg &HC0 + chan%, ASC(MID$(inst$, 11, 1))
END SUB

SUB FMStopNote (chan%)             'Stop any sound on specified channel
 WriteReg &HB0 + chan%, 0
END SUB

SUB PlayNextNote STATIC           'This SUB plays the next not if it's time
 Now! = TIMER
 IF Now! > NextTime! THEN                     'Check if it's time
  FOR n% = 0 TO 8                             'Stop channel when note change
   IF Music(n%, NoteNum%) <> Music(n%, Last%) THEN FMStopNote n%
  NEXT n%
  FOR n% = 0 TO 8                             'Play notes
   IF Music(n%, NoteNum%) > 0 THEN
    note% = (Music(n%, NoteNum%) + Pitch%) MOD 12
    octv% = INT((Music(n%, NoteNum%) + Pitch%) / 12)
    FMPlayNote n%, note%, octv%
   ELSE
    FMPlayNote n%, 0, 0
   END IF
  NEXT n%
  Last% = NoteNum%                            'Remember last note
  NoteNum% = NoteNum% + 1
  NextTime! = Now! + Delay!
  IF NextTime! > 86400 THEN NextTime! = 0
 END IF
END SUB

FUNCTION ReadXSM% (musx$)                             'Read an XSM file
 FileNum% = FREEFILE
 OPEN musx$ FOR BINARY ACCESS READ AS #FileNum%       'eXtra Simple Music format
  id$ = "ofTAZ!"
  GET #FileNum%, , id$                                'Read ID
  IF id$ <> "ofTAZ!" THEN ReadXSM% = 1: EXIT FUNCTION 'Incorrect ID
  GET #FileNum%, , SongLen%                           'Read length of song
  IF SongLen% > 3200 THEN ReadXSM% = 2: EXIT FUNCTION 'Song to long
  FOR n% = 0 TO 8
   GET #FileNum%, , InstType(n%)                      'Read instruments for each
  NEXT n%                                             'channel
  x$ = CHR$(0)
  FOR n% = 0 TO 8
   FOR z% = 0 TO SongLen% - 1
    IF EOF(1) THEN ReadXSM% = 3: EXIT FUNCTION        'End of file reached
    GET #FileNum%, , x$                               'Read music
    Music(n%, z%) = ASC(x$)
   NEXT z%
  NEXT n%
 CLOSE #FileNum%
 ReadXSM% = 0
END FUNCTION

FUNCTION SongLength!
 SongLength! = INT(SongLen% / (1 / Delay!) * 10) / 10
END FUNCTION

SUB VarInit                      'Initialise variables
 NoteF%(0) = &H16B
 NoteF%(1) = &H181
 NoteF%(2) = &H198
 NoteF%(3) = &H1B0
 NoteF%(4) = &H1CA
 NoteF%(5) = &H1E5
 NoteF%(6) = &H202
 NoteF%(7) = &H220
 NoteF%(8) = &H241
 NoteF%(9) = &H263
 NoteF%(10) = &H287
 NoteF%(11) = &H2AE
 FOR n% = 0 TO 8
  FOR z% = 1 TO 3199
   Music(n%, z%) = 0
  NEXT z%
 NEXT n%
END SUB

SUB WriteReg (reg%, info%)              'Write to FM register
 OUT &H388, reg%
 FOR d% = 1 TO 6: x% = INP(&H388): NEXT d%
 OUT &H389, info%
 FOR d% = 1 TO 35: x% = INP(&H388): NEXT d%
END SUB

