'---- -  
'        ** FM MUSIC SEQUENCER (FM LIB DEMO) **
'               Created by Davey W Taylor
'
' Check out the code on how to use the FMLIB.BAS routines.
' Features: Background play, speed change, pitch and a nice, colored
'           scroller + something which I don't remember..
'---     
' ** If you have any comments / suggestions / questions, my email is: **
' ** audio.squad@mailbox.swipnet.se                         <<< EMAIL **

DECLARE FUNCTION Detect% ()
DECLARE FUNCTION ReadXSM% (musx$)
DECLARE FUNCTION SongLength! ()
DECLARE SUB FMInit ()
DECLARE SUB VarInit ()
DECLARE SUB FMSetInstrument (chan%, inst$)
DECLARE SUB PlayNextNote ()
DECLARE SUB FMPlayNote (chan%, note%, octv%)
DECLARE SUB FMStopNote (chan%)
DECLARE SUB WriteReg (reg%, info%)
DIM SHARED Delay!
DIM SHARED NoteNum%, SongLen%
DIM SHARED Music(8, 3199) AS INTEGER       'memory for 9 channels & 3200 notes
DIM SHARED NoteF(12) AS INTEGER
DIM SHARED InstType(8) AS STRING * 16
DIM SHARED Pitch%

'Speed test for some computers:
' 486DX2 33MHz 108.7%
' 486DX4 80MHz 108.6%
' P133         108.6%

'Tested with theese FM cards:
' Aztech Sound Galaxy
' Sound Blaster 16
' Sound Blaster Pro

CLS
IF Detect% THEN                                         'Check for FM and
 PRINT "FM detected!"                                   'initialize...
 PRINT "Initialising FM (rough)... ";
 FMInit
 PRINT "Done!"
 PRINT "Initialising program... ";
 VarInit
 PRINT "Done!"
ELSE
 PRINT "FM not detected!"
 END
END IF

Delay! = .2                                             'Set note rate

PRINT
PRINT "These song should come with the program:"        'Display menu and
PRINT " A - CHILD1.XSM"                                 'get which song to
PRINT " B - EASY1.XSM"                                  'play
PRINT " C - FANTASY1.XSM"
PRINT " D - JUNGLE1.XSM"
PRINT " ENTER - Other..."
PRINT
PRINT "Please make a selection or press ESC to quit...";
DO
 SELECT CASE UCASE$(INKEY$)
  CASE "A": musx$ = "child1.xsm"
  CASE "B": musx$ = "easy1.xsm"
  CASE "C": musx$ = "fantasy1.xsm"
  CASE "D": musx$ = "jungle1.xsm"
  CASE CHR$(13)
   LOCATE , 1: PRINT STRING$(60, 32);
   LOCATE , 1: LINE INPUT "Please enter filename: ", musx$
   LOCATE CSRLIN - 1
   IF musx$ = "" THEN musx$ = " "
  CASE CHR$(27): END
 END SELECT
LOOP WHILE musx$ = ""
PRINT
PRINT

PRINT "Reading "; UCASE$(musx$); "..."                  'Read instruments and
ON ERROR GOTO NotFound                                  'song
 OPEN musx$ FOR INPUT AS #1: CLOSE #1
ON ERROR GOTO 0
SELECT CASE ReadXSM%(musx$)
 CASE 1: PRINT " Incorrect ID!": END
 CASE 2: PRINT " Sont to long!": END
 CASE 3: PRINT " End of file reached!": END
 CASE 0: PRINT " File OK!"
END SELECT
PRINT
PRINT "Music length:"; SongLength!; "seconds"        'Print song length

FOR n% = 0 TO 8
 FMSetInstrument n%, InstType(n%)
NEXT n%

s! = TIMER
text$ = "Playing in background!!! Press ESC to Quit, C to change color, up/down arrow keys change pitch and left/right change speed..."
text$ = text$ + STRING$(20, 32)
c% = 12
DO
 PlayNextNote                                   'Play next note if it is time
                                                'This is the only line that
                                                'you will need to keep the
                                                'music playing!!!!
 IF NoteNum% = SongLen% THEN
  NoteNum% = 0                                  'Repeat and reset timer
  s! = TIMER
 END IF

 LOCATE 18, 1: PRINT "Current time: ";          'Update status
 t! = INT((TIMER - s!) * 10) / 10
 IF t! < 1 AND t! > 0 THEN PRINT "0";
 PRINT LTRIM$(STR$(t!));
 IF t! = INT(t!) THEN PRINT ".0";
 PRINT "  ";
 LOCATE 19, 1: PRINT "Pitch/Speed : "; LTRIM$(STR$(Pitch%)); "/"; LTRIM$(STR$(spd%)); " ";

 IF t! <> lt! THEN
  text$ = MID$(text$, 2) + LEFT$(text$, 1)
  COLOR c%
  LOCATE 23: PRINT LEFT$(text$, 80);
  COLOR 7
  lt! = t!
 END IF

 SELECT CASE INKEY$                             'Check keys
  CASE "C", "c"                                 'Change color
   c% = (c% + 1) MOD 16
   IF c% = 0 THEN c% = 1
  CASE CHR$(0) + "H"                            'Change pitch
   IF Pitch% < 10 THEN
    Pitch% = Pitch% + 1
   END IF
  CASE CHR$(0) + "P"
   IF Pitch% > -10 THEN
    Pitch% = Pitch% - 1
   END IF
  CASE CHR$(0) + "K"                            'Change speed
   IF spd% > -4 THEN
    Delay! = Delay! + .05
    spd% = spd% - 1
   END IF
  CASE CHR$(0) + "M"
   IF spd% < 4 THEN
    Delay! = Delay! - .05
    spd% = spd% + 1
   END IF
  CASE CHR$(27)                                 'Stop music and quit
   FOR n% = 0 TO 8
    FMStopNote n%
   NEXT n%
   END
 END SELECT
LOOP
NotFound:
 PRINT " File not found!"
 END

FUNCTION Detect%
 WriteReg 4, &H60
 WriteReg 4, &H80
 data1% = INP(&H388)
 WriteReg 2, &HFF
 WriteReg 4, &H21
 FOR d% = 1 TO 150: x% = INP(&H388): NEXT d%
 data2% = INP(&H388)
 WriteReg 4, &H60
 WriteReg 4, &H80
 IF (data1% AND &HE0) = 0 AND (data2% AND &HE0) = &HC0 THEN Detect% = -1
END FUNCTION

SUB FMInit
 FOR n% = 0 TO &HF5
  WriteReg n%, 0
 NEXT n%
END SUB

SUB FMPlayNote (chan%, note%, octv%)
 freq% = NoteF%(note%)
 IF note% = 0 AND octv% = 0 THEN freq% = 0
 WriteReg &HA0 + chan%, freq% AND &HFF
 WriteReg &HB0 + chan%, INT(freq% / 256) OR 32 OR (octv% * 4)
END SUB

SUB FMSetInstrument (chan%, inst$)
 chanx% = (chan% MOD 3) + 8 * INT(chan% / 3)
 
' LOCATE 10, 1: PRINT chanx%

 WriteReg &H20 + chanx%, ASC(MID$(inst$, 1, 1)) 'AMP/VIB/EG/KSR/MFM
 WriteReg &H23 + chanx%, ASC(MID$(inst$, 2, 1))
 WriteReg &H40 + chanx%, ASC(MID$(inst$, 3, 1)) 'LKS/TL
 WriteReg &H43 + chanx%, ASC(MID$(inst$, 4, 1))
 WriteReg &H60 + chanx%, ASC(MID$(inst$, 5, 1)) 'AR/DR
 WriteReg &H63 + chanx%, ASC(MID$(inst$, 6, 1))
 WriteReg &H80 + chanx%, ASC(MID$(inst$, 7, 1)) 'SL/RR
 WriteReg &H83 + chanx%, ASC(MID$(inst$, 8, 1))
 WriteReg &HE0 + chanx%, ASC(MID$(inst$, 9, 1)) 'WFS
 WriteReg &HE3 + chanx%, ASC(MID$(inst$, 10, 1))
 WriteReg &HC0 + chan%, ASC(MID$(inst$, 11, 1))
END SUB

SUB FMStopNote (chan%)
 WriteReg &HB0 + chan%, 0
END SUB

SUB PlayNextNote STATIC
 Now! = TIMER
 IF Now! > NextTime! THEN
  FOR n% = 0 TO 8
   IF Music(n%, NoteNum%) <> Music(n%, Last%) THEN FMStopNote n%
  NEXT n%
  FOR n% = 0 TO 8
   IF Music(n%, NoteNum%) > 0 THEN
    note% = (Music(n%, NoteNum%) + Pitch%) MOD 12
    octv% = INT((Music(n%, NoteNum%) + Pitch%) / 12)
    FMPlayNote n%, note%, octv%
   ELSE
    FMPlayNote n%, 0, 0
   END IF
  NEXT n%
  Last% = NoteNum%
  NoteNum% = NoteNum% + 1
  NextTime! = Now! + Delay!
  IF NextTime! > 86400 THEN NextTime! = 0
 END IF
END SUB

FUNCTION ReadXSM% (musx$)
 FileNum% = FREEFILE
 OPEN musx$ FOR BINARY ACCESS READ AS #FileNum%       'eXtra Simple Music format
  id$ = "ofTAZ!"
  GET #FileNum%, , id$                                'Read ID
  IF id$ <> "ofTAZ!" THEN ReadXSM% = 1: EXIT FUNCTION 'Incorrect ID
  GET #FileNum%, , SongLen%                           'Read length of song
  IF SongLen% > 3200 THEN ReadXSM% = 2: EXIT FUNCTION 'Song to long
  FOR n% = 0 TO 8
   GET #FileNum%, , InstType(n%)                      'Read instruments for each
  NEXT n%                                             'channel
  x$ = CHR$(0)
  FOR n% = 0 TO 8
   FOR z% = 0 TO SongLen% - 1
    IF EOF(1) THEN ReadXSM% = 3: EXIT FUNCTION        'End of file reached
    GET #FileNum%, , x$                               'Read music
    Music(n%, z%) = ASC(x$)
   NEXT z%
  NEXT n%
 CLOSE #FileNum%
 ReadXSM% = 0
END FUNCTION

FUNCTION SongLength!
 SongLength! = INT(SongLen% / (1 / Delay!) * 10) / 10
END FUNCTION

SUB VarInit
 NoteF%(0) = &H16B
 NoteF%(1) = &H181
 NoteF%(2) = &H198
 NoteF%(3) = &H1B0
 NoteF%(4) = &H1CA
 NoteF%(5) = &H1E5
 NoteF%(6) = &H202
 NoteF%(7) = &H220
 NoteF%(8) = &H241
 NoteF%(9) = &H263
 NoteF%(10) = &H287
 NoteF%(11) = &H2AE
 'notef%(0) = &H156
 'notef%(1) = &H16B
 'notef%(2) = &H181
 'notef%(3) = &H198
 'notef%(4) = &H1B0
 'notef%(5) = &H1CA
 'notef%(6) = &H1E5
 'notef%(7) = &H202
 'notef%(8) = &H220
 'notef%(9) = &H241
 'notef%(10) = &H263
 'notef%(11) = &H287
 FOR n% = 0 TO 8
  FOR z% = 1 TO 3199
   Music(n%, z%) = 0
  NEXT z%
 NEXT n%

 'Harp(0) = 242
 'Harp(1) = 18
 'Harp(2) = 144
 'Harp(3) = 1
 'Harp(4) = 242
 'Harp(5) = 243
 'Harp(6) = 18
 'Harp(7) = 180
 'Harp(8) = 1
 'Harp(9) = 1
 'Harp(10) = 7
 'Harp(11) = 1

END SUB

SUB WriteReg (reg%, info%)
 OUT &H388, reg%
 FOR d% = 1 TO 6: x% = INP(&H388): NEXT d%
 OUT &H389, info%
 FOR d% = 1 TO 35: x% = INP(&H388): NEXT d%
END SUB

